//Create a class for Events
package Event
import groovy.json.JsonSlurper

public class Event {
	private String deviceId
	private String value
	private String linkText
	private String displayName
	private boolean displayed
	private String name
	private String descriptionText
	private boolean isStateChange
	private String unit
	private String data
	private jsonData
	private int integerValue
	private double doubleValue
	private List integerValues = ["battery", "hue", "saturation", "energy", "level", "temperature", 
				      "heatingSetpoint", "coolingSetpoint", "thermostatSetpoint", "illuminance"]
	
	Event(String value, String name, String deviceId, String descriptionText, boolean displayed, String linkText, String displayName, boolean isStateChange, String unit, String data) {
		this.deviceId = deviceId
		this.linkText = linkText
		this.value = value
		this.displayName = displayName
		this.name = name
		this.descriptionText = descriptionText
		this.isStateChange = isStateChange
		this.unit = unit
		this.data = data
		this.jsonData = new groovy.json.JsonSlurper().parseText(data)
		this.displayed = displayed
		if (integerValues.contains(name)) {
			this.integerValue = value.toInteger()
			this.doubleValue = Double.parseDouble(value);		
		}
	}
}
